  /***
   * Copyright (c) 2002 by Columbia University. All rights reserved.
   *
   * To run this program, you have to install OpenSLP package that 
   * can be downloaded from www.openslp.org.
   * For demonstration, use the slptool function in OpenSLP package
   * to register the following server.  This function may located 
   * in openslp-x.x.x/slptool/ directory.  
   * The following is the example from registration.
   *
   * ./slptool register service:printer://marta.cs.columbia.edu "(speed=200)"
   * ./slptool register service:printer://paris.clic.cs.columbia.edu "(speed=10)"
   * ./slptool register service:iptel-gw://baghdad.clic.cs.columbia.edu "(iptel-gw-prefix-list=1212,4930,8610),(iptel-gw-total-capacity=300),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:5,1:10,:20)"
   * ./slptool register service:iptel-gw://dehli.clic.cs.columbia.edu "(iptel-gw-prefix-list=4930,1212),(iptel-gw-total-capacity=30),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:5,1:10,:20)"
   * ./slptool register service:iptel-gw://cairo.clic.cs.columbia.edu "(iptel-gw-total-capacity=300),(iptel-gw-remaining-capacity=100)"
   * ./slptool register service:iptel-gw://munchen.clic.cs.columbia.edu "(iptel-gw-prefix-list=1212,4930,8610),(iptel-gw-total-capacity=300),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:5,1:10,:10)"
   * ./slptool register service:iptel-gw://jakarta.clic.cs.columbia.edu "(iptel-gw-prefix-list=1212,4930,8610),(iptel-gw-total-capacity=30),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:10,1:10,:10)"
   *
   ***/

#include <iostream.h>
#include <stdio.h>
#include <string.h>

#include "gwloc.h"

int main(int argc, char *argv[])
{
  int i;


  /* Various example of queries is provided here */
//  char msg[1024];
//  char msg[] = "slp://example.com/SrvRqst??type=printer";
  char msg[] = "slp:///SrvRqst??type=iptel-gw";   
//  char msg[] =  "slp:///SrvRqst??type=printer;pred=(speed%3e%3d15)";
//  char msg[] =  "slp:///SrvRqst??type=printer;pred=(speed%3e%3d15);spi=test";
//  char msg[] =  "slp:///SrvRqst??na=-1";
//  char msg[] =  "slp://example.com/SrvRqst?public?type=printer?ext=attr";
//  char msg[] =  "slp:///AttrRqst??url=service:iptel-gw://minsk.clic.cs.columbia.edu";
//  char msg[] =  "slp:///AttrRqst??url=service:iptel-gw://jakarta.clic.cs.columbia.edu";
//  char msg[] =  "slp:///AttrRqst??url=service:iptel-gw://dehli.clic.cs.columbia.edu";
//  char msg[] =  "slp:///AttrRqst??url=service:printer2://beirut.clic.cs.columbia.edu";
//  char msg[] =  "slp:///SrvRqst??type=iptel-gw;pred=(c%3e%3d15)";
//  char msg[] = "slp:///SrvTypeRqst??na=""";
//  char msg[] = "1-212-890-7724";
//  char msg[] =  "slp:///SrvRqst??type=iptel-gw;pred=(%26(c%3e%3d10)(d%3c20))";
//  char msg[] =  "slp:///SrvRqst??type=iptel-gw;pred=(%7c(c%3e%3d10)(d%3c20))";
//  char msg[] = "slp:///SrvRqst??type=printer;pred=(speed%3e%3d15)";
//  char msg[] =  "slp:///SrvRqst??type=iptel-gw;pred=(iptel-gw-prefix-list%3d1212)"; 
//  char msg[] = "tel:8-610-890-7724";
//  char msg[] = "tel:4-930-890-7724";
  
  /* Various filter example is provided here */
//  char *filter = NULL;
//  char filter[400];
//  char filter[] = "c=h,d=h";
//  char filter[] = "c=303,d=l";
  char filter[]= "iptel-gw-cost-list=h,c=l";


  gwloc_t *GwLoc;
  char **result;
  int *lifetime;
  int size, err;


  GwLoc = (gwloc_t *) malloc(sizeof(gwloc_t));
  err = Query(GwLoc, msg, filter);
  size = GetSize(GwLoc);

  result = (char **) malloc(sizeof(char *) * size);
  lifetime = (int *) malloc(sizeof(int) * size);
  GetResult(GwLoc, result, lifetime);
  
  printf("OUTPUT:\n");
  for (i = 0; i < size; i++) {
    printf("%s\n", result[i]);
  }

  FreeGwLoc(GwLoc);
  free(result);
  free(lifetime);
     
} /* main() */

