  /***
   * Copyright (c) 2002 by Columbia University. All rights reserved.
   *
   * To run this program, you have to install OpenSLP package that 
   * can be downloaded from www.openslp.org.
   * For demonstration, use the slptool function in OpenSLP package
   * to register the following server.  This function may located 
   * in openslp-x.x.x/slptool/ directory.  
   * The following is the example from registration.
   *
   * ./slptool register service:printer://marta.cs.columbia.edu "(speed=200)"
   * ./slptool register service:printer://paris.clic.cs.columbia.edu "(speed=10)"
   * ./slptool register service:iptel-gw://baghdad.clic.cs.columbia.edu "(iptel-gw-prefix-list=1212,4930,8610),(iptel-gw-total-capacity=300),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:5,1:10,:20)"
   * ./slptool register service:iptel-gw://dehli.clic.cs.columbia.edu "(iptel-gw-prefix-list=4930,1212),(iptel-gw-total-capacity=30),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:5,1:10,:20)"
   * ./slptool register service:iptel-gw://cairo.clic.cs.columbia.edu "(iptel-gw-total-capacity=300),(iptel-gw-remaining-capacity=100)"
   * ./slptool register service:iptel-gw://munchen.clic.cs.columbia.edu "(iptel-gw-prefix-list=1212,4930,8610),(iptel-gw-total-capacity=300),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:5,1:10,:10)"
   * ./slptool register service:iptel-gw://jakarta.clic.cs.columbia.edu "(iptel-gw-prefix-list=1212,4930,8610),(iptel-gw-total-capacity=30),(iptel-gw-remaining-capacity=10),(iptel-gw-cost-list=1212:10,1:10,:10)"
   *
   ***/

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <readline/readline.h>

#include "gwloc.h"

#define MAXLINE 4000

typedef struct t_myarg {
  char host[MAXLINE];
  int port;
  char msg[MAXLINE];
} myarg; 

void *sendquery(void *arg);

int main (int argc, char *argv[])
{
  char query_msg[MAXLINE];
  char msg[MAXLINE];
  char filter[MAXLINE];
  pthread_t   tid;
  myarg *thearg;
  char *result;


  thearg = (myarg *) malloc(sizeof(myarg));

  if (argc == 4) {
    strcpy(msg, argv[2]);
    strcpy(thearg->host, strdup(argv[1]));
    thearg->port = atoi(argv[3]);
    strcpy(filter, "");
  }

  if (argc == 5) {
    strcpy(msg, argv[2]);
    strcpy(filter, argv[3]);
    strcpy(thearg->host, strdup(argv[1]));
    thearg->port = atoi(argv[4]);
  }

  if ((argc < 4) || (argc > 5)) {
    printf("usage: demo2cli <IPaddress> <query> [filter] <port>\n");
    exit(0);
  }


  strcpy(query_msg, msg);
  strcat(query_msg, "|");
  strcat(query_msg, filter);

  
  strcpy(thearg->msg, query_msg);

  pthread_create(&tid, NULL, sendquery, (void *) thearg);

  pthread_join(tid, (void **) &result);

  exit(0);


}

void *sendquery(void *arg)
{
  char sendline[MAXLINE], recvline[MAXLINE];
  myarg *doitarg;
  int n;
  struct sockaddr_in servaddr;
  char *ret;
  int sockfd;
  char *token;


  doitarg = (myarg *) arg;

  sockfd = socket(AF_INET, SOCK_STREAM, 0);

  bzero(&servaddr, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_port = htons(doitarg->port);
  inet_pton(AF_INET, doitarg->host, &servaddr.sin_addr);

  connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr));

  strcpy(sendline, doitarg->msg);

  n = send(sockfd, sendline, strlen(sendline), 0);

  for(;;) {
    n = recv(sockfd, recvline, MAXLINE, 0);
    if (n > 0) {
      recvline[n] = '\0';

      ret = strdup(recvline);

      token = strtok( ret, "|" );
      while( token != NULL )
      {
        printf( " %s\n", token );
        token = strtok( NULL, "|" );
      }

      ret = strdup(recvline);
    }
  }
  close(sockfd);

  return (ret);
}


